\chapter{Data and Queries}

\section{Data}
For this seminar work, we used the database frozendata \cite{Frozendata} from 'Freie Universität Berlin' \cite{fu-berlin}. This database is suitable for this task because it is pretty huge, has "indexable" data and is a pretty good resemblance of a real data set.\\
Then we used some queries to benchmark the data retrieval before and after the automated indexes suggested by Dexter. The benchmark queries and the step-by-step instructions to get the data can be found inside the join-order-benchmark \cite{join-order-benchmark} GitHub repository.
\subsection{Data Import}
The files can be unpacked with imdbpy \cite{imdbpy}, which was causing problems in a Windows environment. Therefore, the Linux operating system had to be used. To run Linux under a Windows Operating System, the Oracle VM Virtual Box Manager application can be used. For the virtual machine, we need at least 100GB storage to have no space problems afterwards. The import of the data took quite some time, around 10 hours. At the end of the import, an error message was shown:
\begin{lstlisting}[breaklines]
2019-11-26 15:30:04,889 WARNING [imdbpy.parser.sql.alchemy] /usr/local/lib/python3.8/site-packages/imdb/parser/sql/alchemyadapter.py:342: Skipping creation of the movie\_info.info index: (psycopg2.errors.ProgramLimitExceeded) index row requires 16536 bytes, maximum size is 8191
[SQL: CREATE INDEX movie_info_idx_info ON movie_info (info)]
(Background on this error at http://sqlalche.me/e/e3q8)
\end{lstlisting}
More information about issues with the data is available in the section 'Issues with the database'. Nevertheless, in the end, we see that everything works. The output from a Linux server (no virtualization):
\begin{lstlisting}[breaklines]
# TIME FINAL : 292min, 43sec (wall) 72min, 53sec (user) 47min, 38sec (system)
2019/11/26 15:30:58 Command finished successfully.
\end{lstlisting}
\subsection{Data Analysis}
In our database, we have 20 relations with a total size of 23GB. The biggest relation is 'cast\_info' with 7 attributes and 63'475'835 rows which corresponds to 3'478MB of data. It contains many-to-many-relations and multiple join paths in-between entities.
\subsection{Issues with the database}
After loading all the data to the database, the relation movie\_info\_idx was missing. The reason for this is unknown, but a simple solution has been found. Simply find and replace all the occurrences of 'movie\_info\_idx' with 'movie\_info', and the queries will work. 
\section{Query Plan}
In this project, we used a pretty interesting feature of PostgreSQL, which is called \textit{EXPLAIN ANALYZE}.\\
This tool is pretty powerful since it gives us a far better understanding of the query executed and the process it went through before finally retrieving the results. This can then be efficiently used to optimize our database in various ways (in our case, using indexes).\\
It can be used in conjunction with \textit{SELECT...}, \textit{UPDATE...} or \textit{DELETE...} query functions.\\
\newline
The structure of a query plan is a tree of plan nodes. Nodes at the bottom level of the tree are scan nodes: they return raw rows from a table. There are different types of scan nodes for different table access methods: sequential scans, index scans, and bitmap index scans. There are also non-table row sources, such as VALUES clauses and set-returning functions in FROM, which have their own scan node types. If the query requires joining, aggregation, sorting, or other operations on the raw rows, then there will be additional nodes above the scan nodes to perform these operations. Again, there is usually more than one possible way to do these operations, so different node types can appear here too. The output of EXPLAIN has one line for each node in the plan tree, showing the basic node type plus the cost estimates that the planner made for the execution of that plan node. \cite{PostgresExplainAnalyze}
\\
\newpage
Here, we are going to take an example Query Plan for this database and analyze it: \\
\begin{lstlisting}[breaklines]
                              QUERY PLAN 
 --------------------------------------------------------------------------------------
 Finalize Aggregate  (cost=72638.52..72638.53 rows=1 width=68) (actual time=16228.424..16228.425 rows=1 loops=1)
   ->  Gather  (cost=72638.29..72638.50 rows=2 width=68) (actual time=16228.405..16229.937 rows=3 loops=1)
         Workers Planned: 2
         Workers Launched: 2
         ->  Partial Aggregate  (cost=71638.29..71638.30 rows=1 width=68) (actual time=16218.041..16218.042 rows=1 loops=3)
               ->  Hash Join  (cost=16.11..71638.14 rows=21 width=45) (actual time=3.548..16177.726 rows=11932 loops=3)
                     Hash Cond: (mi_idx.info_type_id = it.id)
                     ->  Nested Loop  (cost=13.69..71629.21 rows=2389 width=49) (actual time=1.481..15956.076 rows=812925 loops=3)
                           ->  Nested Loop  (cost=13.12..71441.91 rows=71 width=53) (actual time=0.554..3376.389 rows=19075 loops=3)
                                 ->  Hash Join  (cost=12.69..71059.21 rows=71 width=28) (actual time=0.130..1471.984 rows=19281 loops=3)
                                       Hash Cond: (mc.company_type_id = ct.id)
                                       ->  Parallel Seq Scan on movie_companies mc  (cost=0.00..71013.24 rows=12599 width=32) (actual time=0.054..1447.643 rows=19437 loops=3)
                                             Filter: ((note !~~ '%(as Metro-Goldwyn-Mayer Pictures)%'::text) AND ((note ~~ '%(co-production)%'::text) OR (note ~~ '%(presents)%'::te
xt)))
                                             Rows Removed by Filter: 1633329
                                       ->  Hash  (cost=12.64..12.64 rows=4 width=4) (actual time=0.049..0.050 rows=1 loops=3)
                                             Buckets: 1024  Batches: 1  Memory Usage: 9kB
                                             ->  Bitmap Heap Scan on company_type ct  (cost=4.18..12.64 rows=4 width=4) (actual time=0.029..0.045 rows=1 loops=3)
                                                   Recheck Cond: ((kind)::text = 'production companies'::text)
                                                   Heap Blocks: exact=1
                                                   ->  Bitmap Index Scan on company_type_kind  (cost=0.00..4.18 rows=4 width=0) (actual time=0.018..0.018 rows=1 loops=3)
                                                         Index Cond: ((kind)::text = 'production companies'::text)
                                 ->  Index Scan using title_pkey on title t  (cost=0.43..5.39 rows=1 width=25) (actual time=0.097..0.097 rows=1 loops=57843)
                                       Index Cond: (id = mc.movie_id)
                           ->  Index Scan using movie_info_idx_mid on movie_info mi_idx  (cost=0.56..2.01 rows=63 width=8) (actual time=0.238..0.643 rows=43 loops=57226)
                                 Index Cond: (movie_id = t.id)
                     ->  Hash  (cost=2.41..2.41 rows=1 width=4) (actual time=0.049..0.050 rows=1 loops=3)
                           Buckets: 1024  Batches: 1  Memory Usage: 9kB
                           ->  Seq Scan on info_type it  (cost=0.00..2.41 rows=1 width=4) (actual time=0.045..0.046 rows=1 loops=3)
                                 Filter: ((info)::text = 'top 250 rank'::text)
                                 Rows Removed by Filter: 112
 Planning Time: 1.734 ms
 Execution Time: 16230.055 ms
\end{lstlisting}
\newpage
The query plan above was taken after executing the \textit{1a.sql} benchmark query which looks like this:
\begin{lstlisting}[breaklines]
SELECT MIN(mc.note) AS production_note,
       MIN(t.title) AS movie_title,
       MIN(t.production_year) AS movie_year
FROM company_type AS ct,
     info_type AS it,
     movie_companies AS mc,
     movie_info AS mi_idx,
     title AS t
WHERE ct.kind = 'production companies'
  AND it.info = 'top 250 rank'
  AND mc.note NOT LIKE '%(as Metro-Goldwyn-Mayer Pictures)%'
  AND (mc.note LIKE '%(co-production)%'
       OR mc.note LIKE '%(presents)%')
  AND ct.id = mc.company_type_id
  AND t.id = mc.movie_id
  AND t.id = mi_idx.movie_id
  AND mc.movie_id = mi_idx.movie_id
  AND it.id = mi_idx.info_type_id;
\end{lstlisting}

The query plan generated by Postgres is a tree structure of plan nodes that represents different actions that were taken when executing the query; they are marked with a "-$>$". All the other information marked without a "-$>$" is additional execution information.\\
\newline
The structure of a query plan looks something like this, although it might change depending on the query (whether it contains aggregation, parallelism, indexes, etc.):
\begin{lstlisting}[breaklines]
Sort
  -> Hash Join
    -> Seq Scan
      -> Hash
        -> Bitmap Heap Scan
          -> Bitmap Index Scan
\end{lstlisting}
Each node represents sub-actions and in order to find out what happens first one would have to read the results from the most inner node first and then working their way up all the way until the root.\\
\newline
The first thing done here is the \textit{Bitmap Index Scan} on the company\_type\_kind index:
\begin{lstlisting}[breaklines]
->  Bitmap Index Scan on company_type_kind  (cost=0.00..4.18 rows=4 width=0) (actual time=0.018..0.018 rows=1 loops=3)
      Index Cond: ((kind)::text = 'production companies'::text)
\end{lstlisting}
This corresponds to the \textit{WHERE ct.kind = 'production companies'} condition. Postgres here tries to estimate how long it will take to find these values; it doesn't ACTUALLY return the rows.\\
\textit{cost(4.18)} is the estimated arbitrary unit of computation it will take to find these values.\\
\textit{rows=4} is the estimated number of rows this index scan will return and \textit{width=0} is the estimated size in bytes of the returned rows (0 in this case because it is only scanning the location of the records, not the actual content).\\
\textit{actual time} means that the query was executed and the timing information was captured. It was executed three times (loops) and returned one row; actual time is an average time of all the times this was executed, in this case, 3.\\
\newline
These results are then sent to a \textit{Bitmap Heap Scan} action. In this specific node, Postgres takes the locations of the rows found from the index scan and fetches those rows from the table itself.
\begin{lstlisting}[breaklines]
->  Bitmap Heap Scan on company_type ct  (cost=4.18..12.64 rows=4 width=4) (actual time=0.029..0.045 rows=1 loops=3)
\end{lstlisting}
The results of the heap scan, the rows which fulfil the condition (in this case the company type kind condition) are inserted then into an in-memory Hash table while they're being read. This step takes almost no time at all. It contains information about the hash buckets, batches and the highest memory usage reached while performing this step.
\begin{lstlisting}[breaklines]
->  Hash  (cost=12.64..12.64 rows=4 width=4) (actual time=0.049..0.050 rows=1 loops=3)
      Buckets: 1024  Batches: 1  Memory Usage: 9kB
\end{lstlisting}
Next, Postgres reads all the results from movie\_companies table(aliased as mc) and checks them against the hash of the company\_type (ct) rows taken before, the hash condition under which the Hash join is done can be seen at the \textit{Hash Cond: (mc.company\_type\_id = ct.id)} row that displays the condition of the Hash join. The width of the rows doubles because of the join now (because we select all the data from the first and second table).
\begin{lstlisting}[breaklines]
->  Hash Join  (cost=12.69..71059.21 rows=71 width=28) (actual time=0.130..1471.984 rows=19281 loops=3)
      Hash Cond: (mc.company_type_id = ct.id)
\end{lstlisting}
Next, Postgres does a Parallel Sequential Scan, which is a normal scan that reads from the first row and below one by one until it finds the desired records. This is done when an index is not available. Parallel Sequential Scans were added in Postgres 9.6 \cite{PostgresParallelQuery} but normal Sequential Scans were available from the beginning.\\
\newline
This scan corresponds to the \textit{mc.note NOT LIKE '\%(as Metro-Goldwyn-Mayer Pictures)\%'} condition.
\begin{lstlisting}[breaklines]
 ->  Parallel Seq Scan on movie_companies mc  (cost=0.00..71013.24 rows=12599 width=32) (actual time=0.054..1447.643 rows=19437 loops=3)
      Filter: ((note !~~ '%(as Metro-Goldwyn-Mayer Pictures)%'::text) AND ((note ~~ '%(co-production)%'::text) OR (note ~~ '%(presents)%'::text)))
      Rows Removed by Filter: 1633329
\end{lstlisting}
The \textit{Partial Aggregate, Gather} and \textit{Finalize Aggregate} nodes in the beginning of the query plan (in the end if we view it chronologically) are rows that include data about the data aggregation done in the query (because we used aggregate functions in our query).\\
\begin{lstlisting}[breaklines]
Finalize Aggregate  (cost=72638.52..72638.53 rows=1 width=68) (actual time=16228.424..16228.425 rows=1 loops=1)
   ->  Gather  (cost=72638.29..72638.50 rows=2 width=68) (actual time=16228.405..16229.937 rows=3 loops=1)
         Workers Planned: 2
         Workers Launched: 2
         ->  Partial Aggregate  (cost=71638.29..71638.30 rows=1 width=68) (actual time=16218.041..16218.042 rows=1 loops=3)
\end{lstlisting}
PostgreSQL supports parallel aggregation by aggregating in two stages. First, each process participating in the parallel portion of the query performs an aggregation step, producing a partial result for each group of which that process is aware. This is reflected in the plan as a Partial Aggregate node. Second, the partial results are transferred to the leader via the Gather node. Finally, the leader re-aggregates the results across all workers in order to produce the final result. This is reflected in the plan as a Finalize Aggregate node. \cite{PostgresAggregate}\\
\newline
Finally, the query plan shows the \textit{Planning Time} and the \textit{Execution Time} for the query.\\
\begin{lstlisting}[breaklines]
Planning Time: 1.734 ms
Execution Time: 16230.055 ms
\end{lstlisting}
The Planning Time is the amount of time it took Postgres to figure out the query plan for a specific query.\\
The Execution Time is the amount of time it actually took Postgres to execute that query plan that it created in the Planning step. Usually, the execution time is larger than the planning time.

\section{Queries}
We take the queries from the Join Order Benchmark (JOB) \cite{join-order-benchmark}. It contains 113 queries with joins. Some of them can be found in Appendix.\\
\newline
We can take the first query, \textit{10a.sql}, and analyze it (all the other queries are written in a similar fashion): \\
\begin{lstlisting}[breaklines]
SELECT MIN(chn.name) AS uncredited_voiced_character,
       MIN(t.title) AS russian_movie
FROM char_name AS chn,
     cast_info AS ci,
     company_name AS cn,
     company_type AS ct,
     movie_companies AS mc,
     role_type AS rt,
     title AS t
WHERE ci.note LIKE '%(voice)%'
  AND ci.note LIKE '%(uncredited)%'
  AND cn.country_code = '[ru]'
  AND rt.role = 'actor'
  AND t.production_year > 2005
  AND t.id = mc.movie_id
  AND t.id = ci.movie_id
  AND ci.movie_id = mc.movie_id
  AND chn.id = ci.person_role_id
  AND rt.id = ci.role_id
  AND cn.id = mc.company_id
  AND ct.id = mc.company_type_id;
\end{lstlisting}
Here we have a query which selects from a lot of tables and then joins them using the WHERE condition, on top of that, we also have some explicit where conditions that search only for some specific records. \\
When all of the records have been retrieved, we then select only one record from the whole result set, using the MIN() function which usually selects the first record, in the alphabetical order in our case, that can be different though depending on the database collation.\\
This is a pretty good benchmarking query since it features a lot of SQL common features used when querying in a real-life scenario.

\subsection{Problems with the Queries}
On executing Query 8c, the database crashes for unknown reasons:
\begin{lstlisting}[breaklines]
WARNING:  terminating the connection because of the crash of another server process
DETAIL:  The postmaster has commanded this server process to roll back the current 
transaction and exit, because another server process exited abnormally and possibly corrupted shared memory.
HINT:  In a moment, you should be able to reconnect to the database and repeat your command.
the server closed the connection unexpectedly
This probably means the server terminated abnormally before or while processing the request.
The connection to the server was lost. Attempting reset: Failed.
\end{lstlisting}
The database was then required to recover itself.